import { BaseApiClient } from "./jsbaseclient_api";
import { DirectMsg, DirectMsgRequest, DirectStreamAPI, JetStreamOptions, Msg, NatsConnection, StoredMsg } from "./types";
import { MsgHdrs } from "./headers";
import { Codec } from "./codec";
export declare class DirectStreamAPIImpl extends BaseApiClient implements DirectStreamAPI {
    constructor(nc: NatsConnection, opts?: JetStreamOptions);
    getMessage(stream: string, query: DirectMsgRequest): Promise<StoredMsg>;
}
export declare class DirectMsgImpl implements DirectMsg {
    data: Uint8Array;
    header: MsgHdrs;
    static jc?: Codec<unknown>;
    constructor(m: Msg);
    get subject(): string;
    get seq(): number;
    get time(): Date;
    get timestamp(): string;
    get stream(): string;
    json<T = unknown>(): T;
    string(): string;
}
