import { JetStreamOptions, KvStatus, Lister, MsgRequest, NatsConnection, ObjectStoreStatus, PurgeOpts, PurgeResponse, StoredMsg, Stream, StreamAPI, StreamConfig, StreamInfo, StreamInfoRequestOptions, StreamMsgResponse, StreamSource, StreamUpdateConfig } from "./types";
import { BaseApiClient } from "./jsbaseclient_api";
import { MsgHdrs } from "./headers";
import { Codec } from "./codec";
export declare function convertStreamSourceDomain(s?: StreamSource): StreamSource;
export declare class StreamAPIImpl extends BaseApiClient implements StreamAPI {
    constructor(nc: NatsConnection, opts?: JetStreamOptions);
    add(cfg?: Partial<StreamConfig>): Promise<StreamInfo>;
    delete(stream: string): Promise<boolean>;
    update(name: string, cfg?: Partial<StreamUpdateConfig>): Promise<StreamInfo>;
    info(name: string, data?: Partial<StreamInfoRequestOptions>): Promise<StreamInfo>;
    list(subject?: string): Lister<StreamInfo>;
    _fixInfo(si: StreamInfo): void;
    purge(name: string, opts?: PurgeOpts): Promise<PurgeResponse>;
    deleteMessage(stream: string, seq: number, erase?: boolean): Promise<boolean>;
    getMessage(stream: string, query: MsgRequest): Promise<StoredMsg>;
    find(subject: string): Promise<string>;
    listKvs(): Lister<KvStatus>;
    listObjectStores(): Lister<ObjectStoreStatus>;
    names(subject?: string): Lister<string>;
    get(name: string): Promise<Stream>;
}
export declare class StoredMsgImpl implements StoredMsg {
    _header?: MsgHdrs;
    smr: StreamMsgResponse;
    static jc?: Codec<unknown>;
    constructor(smr: StreamMsgResponse);
    get subject(): string;
    get seq(): number;
    get timestamp(): string;
    get time(): Date;
    get data(): Uint8Array;
    get header(): MsgHdrs;
    _parse(s: string): Uint8Array;
    json<T = unknown>(): T;
    string(): string;
}
